#include <iostream>
#include <string>
#include <list>
#include "anything.h"

using namespace std;
using nAnything::anything;
 
// teststruct to demonstrate the true generality of anythings
struct teststruct
{
	teststruct(){};
	teststruct( string as ):s(as){}
	// two operators are required in order for anythings to work with the data
	bool operator==( const teststruct& b ){ return s==b.s; }
	bool operator<( const teststruct& b ){ return s<b.s; }
	string s;
};
  
// demonstrating anything as argument without exceptions
void testfunc2( anything any )
{
	string value;
	if( any.get( value ) )
	{
		cout << value << endl;
	}
	else
	{
		cout << "invalid argument for testfunc" << endl;
	}
}

void main()
{
	
	// argument test without exceptions
	anything any2					= "test";
	testfunc2( any2 );
	
	// tree test
	anything tree1;
	// build the tree with arbitary data
	tree1[teststruct("blub")]		= "blublub";
	tree1["test"]					= teststruct();
	tree1[teststruct("test")][10]	= 20;
	tree1["20"]["40"]				= list<int>( 5, 10 );
	// proove it working
	cout << tree1[teststruct("test")][10].as<int>() << endl;
	
	// copy test
	anything tree2=tree1.clone();
	
	// equality test;
	cout << "tree1 and tree2 are equal:" << (tree1==tree2) << endl;
	// make a difference in the tree
	tree1[teststruct("blub")]		= 104.4;
	// proove the difference
	cout << "tree1 and tree2 are equal:" << (tree1==tree2) << endl;
	// test the assigned tree values
	cout << tree2[teststruct("blub")].as<string>() << endl;

	// a graph :) nice
	
	anything one, two;
	one["test"]="test";
	one["test2"]["test"]=one["test"];
	one["test"]="test2";
	cout << one["test2"]["test"].as<string>() << endl;
	
}